<template>
    <div class="omm-action-buttons flex-1-1-auto d-flex align-center justify-end" v-if="isFile" data-test-id="my-test">
        <v-btn-toggle dense group borderless mandatory :value="activeView">
            <app-button
                value="side-by-side"
                icon="mdi-format-columns"
                tooltipText="Markdown and formatted side-by-side"
                @click="setView('side-by-side')"
                class="omm-action-buttons__button--sbs"
            />
            <app-button
                value="markdown"
                icon="mdi-code-tags"
                tooltipText="Markdown view"
                @click="setView('markdown')"
                class="omm-action-buttons__button--markdown"
            />
            <app-button
                value="formatted"
                icon="mdi-format-align-justify"
                tooltipText="Formatted view"
                @click="setView('formatted')"
                class="omm-action-buttons__button--formatted"
            />
        </v-btn-toggle>

        <v-divider vertical/>

        <attachments-menu />

        <app-button
            tooltip-text="Manage variables"
            icon="mdi-code-json" tooltipText="Variables"
            class="omm-action-buttons__button--variables"
        />

        <v-divider vertical />
        <app-button
            icon="mdi-plus"
            tooltipText="New note"
            @click="handleNewNoteClick"
            class="omm-action-buttons__button--new-note"
        />
        <app-button
            icon="mdi-delete-outline"
            tooltipText="Delete note"
            @click="handleDeleteClick"
            class="omm-action-buttons__button--delete-note"
        />
        <v-divider vertical />
        <app-button
            icon="mdi-file-export-outline"
            tooltipText="Export PDF file"
            @click="handleExportPdfClick"
            class="omm-action-buttons__button--export-note"
        />
    </div>
</template>

<script lang="ts">
import { defineComponent, Ref, ref, watch } from '@vue/composition-api';
import {
    useContents,
    useMarkdownRenderer,
    useObservers,
    useViews
} from "@/compositions";
import AppButton from "@/components/AppButton.vue";
import { deleteFile } from "@/ipc";
import { createNewFile } from "@/utils";
import { exportToPdf } from "@/ipc/exportToPdf";
import AttachmentsMenu from "@/components/ActionButtons/AttachmentsMenu.vue";

export default defineComponent({
    name: "ActionButtons",
    components: { AttachmentsMenu, AppButton },
    setup() {
        const activeView = useViews().getViewType();
        const isFile: Ref<boolean> = ref(false);

        const setView = (type: 'side-by-side' | 'markdown' | 'formatted') => {
            useViews().setViewType(type);
        }

        /**
         * On click deletes the current note.
         */
        const handleDeleteClick = async () => {
            await deleteFile();
            const deletedItem = useContents().getCurrentNodeObject.value;
            await useObservers().notifyObservers("itemDeleted", { deletedItem });
        }

        /**
         * Calls the exportToPdf method to open a save file dialog.
         * @todo Notify the user that the export has been successful/unsuccessful.
         */
        const handleExportPdfClick = async () => {
            const containerRef = useMarkdownRenderer().getViewContainerRef.value;
            const rawHtml = containerRef && containerRef.innerHTML;

            if (!rawHtml) return;

            await exportToPdf(rawHtml);
        }

        /**
         * Creates a new note on click.
         */
        const handleNewNoteClick = () => {
            createNewFile();
        }

        watch(useContents().isFile, (newValue) => {
            isFile.value = newValue;
        });

        return {
            isFile,
            setView,
            handleDeleteClick,
            handleNewNoteClick,
            handleExportPdfClick,
            activeView
        }
    }
});
</script>

<style scoped lang="scss">

</style>